.global _start
_start:
	popl	%ecx			// argc
	incl	%ecx			// +1
	movl	%esp,%eax		// (char**)argv
	leal	(%esp,%ecx,4),%ebx	// (char**)envp
	decl	%ecx			// -1
	pushl	%ebx
	pushl	%eax
	pushl	%ecx
	push	$0			// return pointer
	jmp	main

.global execve
execve:
	pushl	%ebx
	movl	16(%esp),%edx
	movl	12(%esp),%ecx
	movl	8(%esp),%ebx
	push	$11
	popl	%eax
	int	$0x80
	jmp	quick_exit

.global waitpid
waitpid:
	push	$7
	jmp	k_entry_edx

.global read
read:
	push	$3
	jmp	k_entry_edx

.global write
write:
	push	$4
	jmp	k_entry_edx

.global open
open:
	push	$5
	jmp	k_entry_edx

.global close
close:
	push	$6
	jmp	k_entry_edx

.global signal
signal:
	push	$48

k_entry_edx:
	popl	%eax
	pushl	%ebx
	movl	16(%esp),%edx
	movl	12(%esp),%ecx
	movl	8(%esp),%ebx
	int	$0x80
	popl	%ebx
	ret

.global pause
pause:
	push	$29
	jmp	k_entry

.global fork
fork:
	push	$2

k_entry:
	popl	%eax
	int	$0x80
	ret

.global	exit
exit:
	movl	4(%esp),%ebx
quick_exit:
	xorl	%eax,%eax
	incl	%eax
	int	$0x80

.global chop
chop:
	movl	4(%esp),%eax
chop.A0:
	movb	(%eax),%cl
	xorb	$'\n',%cl
	je	chop.A1
	incl	%eax
	or	%cl,%cl
	jnz	chop.A0
	ret
chop.A1:
	movb	%cl,(%eax)
	ret

.global str_confpath
str_confpath:
	.string	"/etc/init/"
	.byte	0

.global str_autoopt
str_autoopt:
	.string	"auto"
	.byte	0

.global	bannerfmt
bannerfmt:
	.string	"INIT: twsinit version 0.1 booting (%s)\n"
	.byte	0

.global nullstr
nullstr:
	.string	"(null)"
	.byte	0

.global num
num:
	.long	0x3b9aca00, 0x05f5e100, 0x00989680, 0x000f4240, 0x000186a0
	.long	0x00002710, 0x000003e8, 0x00000064, 0x0000000a, 0x00000000

